# coding: utf-8

"""
    Adobe Target Delivery API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PrefetchResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'views': 'list[View]',
        'page_load': 'PageLoadResponse',
        'mboxes': 'list[PrefetchMboxResponse]',
        'metrics': 'list[Metric]'
    }

    attribute_map = {
        'views': 'views',
        'page_load': 'pageLoad',
        'mboxes': 'mboxes',
        'metrics': 'metrics'
    }

    def __init__(self, views=None, page_load=None, mboxes=None, metrics=None):
        """PrefetchResponse - a model defined in OpenAPI"""

        self._views = None
        self._page_load = None
        self._mboxes = None
        self._metrics = None
        self.discriminator = None

        if views is not None:
            self.views = views
        if page_load is not None:
            self.page_load = page_load
        if mboxes is not None:
            self.mboxes = mboxes
        if metrics is not None:
            self.metrics = metrics

    @property
    def views(self):
        """Gets the views of this PrefetchResponse.

        Contains all the views matching the request. 

        :return: The views of this PrefetchResponse.
        :rtype: list[View]
        """
        return self._views

    @views.setter
    def views(self, views):
        """Sets the views of this PrefetchResponse.

        Contains all the views matching the request. 

        :param views: The views of this PrefetchResponse.
        :type: list[View]
        """

        self._views = views

    @property
    def page_load(self):
        """Gets the page_load of this PrefetchResponse.


        :return: The page_load of this PrefetchResponse.
        :rtype: PageLoadResponse
        """
        return self._page_load

    @page_load.setter
    def page_load(self, page_load):
        """Sets the page_load of this PrefetchResponse.


        :param page_load: The page_load of this PrefetchResponse.
        :type: PageLoadResponse
        """

        self._page_load = page_load

    @property
    def mboxes(self):
        """Gets the mboxes of this PrefetchResponse.

        Prefetched mboxes, including content and notification tokens to be sent back when the mboxes are displayed. 

        :return: The mboxes of this PrefetchResponse.
        :rtype: list[PrefetchMboxResponse]
        """
        return self._mboxes

    @mboxes.setter
    def mboxes(self, mboxes):
        """Sets the mboxes of this PrefetchResponse.

        Prefetched mboxes, including content and notification tokens to be sent back when the mboxes are displayed. 

        :param mboxes: The mboxes of this PrefetchResponse.
        :type: list[PrefetchMboxResponse]
        """

        self._mboxes = mboxes

    @property
    def metrics(self):
        """Gets the metrics of this PrefetchResponse.

        The click track metrics that are not assigned to a view but are present in activites that have views, except in case the same activity is serving content for selectors both assinged to a view and selectors without any views, and having click track metrics that are not assotiated with any view within the activity, then:   * in case of a prefetch only request, these metrics (tokens) will be set in the prefetch response's metrics.   * in case of an execute only request, the metrics will be set in the page load response's metrics.   * in case of a request, with both, execute and prefetch, metrics will be set in the page load response's     metrics only. 

        :return: The metrics of this PrefetchResponse.
        :rtype: list[Metric]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics):
        """Sets the metrics of this PrefetchResponse.

        The click track metrics that are not assigned to a view but are present in activites that have views, except in case the same activity is serving content for selectors both assinged to a view and selectors without any views, and having click track metrics that are not assotiated with any view within the activity, then:   * in case of a prefetch only request, these metrics (tokens) will be set in the prefetch response's metrics.   * in case of an execute only request, the metrics will be set in the page load response's metrics.   * in case of a request, with both, execute and prefetch, metrics will be set in the page load response's     metrics only. 

        :param metrics: The metrics of this PrefetchResponse.
        :type: list[Metric]
        """

        self._metrics = metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrefetchResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
